/**
 * Check if the given data contains any instance of File.
 *
 * @param  {Object} data
 * @return {Boolean}
 */
declare const hasFile: (data: {
    [key: string]: any;
}) => Boolean;
/**
 * Determines if object is file.
 *
 * @param {Object} item
 * @returns {boolean}
 */
declare const isFile: (item: any) => Boolean;
/**
 * Check if the given item is (or contains) a File.
 *
 * @param  {Object|Array} item
 * @return {Boolean}
 */
declare const hasFileDeep: (item: any) => Boolean;
export { hasFile, isFile, hasFileDeep };
